   package me.ashtheking.currency;

   import java.util.*;
   import org.bukkit.entity.Player;

   public class CurrencyList
   {
      private static HashMap<String,PropertyManager> currencys = new HashMap<String,PropertyManager>();
      private static PropertyManager currencyList = new PropertyManager("currencyList.properties");
   
      public static void loadAll()
      {
         for(String s : currencyList.listProperties())
         {
            currencys.put(s,new PropertyManager(s+".properties"));
            System.out.println("Loaded Currency: " + s);
         }
      }
      public static double getValue(String currency, String name)
      {
         try
         {
            return currencys.get(currency.toLowerCase()).getDoubleProperty(name,0);
         }
            catch(NullPointerException npe)
            {
               return -1;
            }
      }
      public static void addCurrency(String currencyName, String itemConvert)
      {
         currencyList.getStringProperty(currencyName.toLowerCase(),itemConvert.toLowerCase());
         currencys = new HashMap<String, PropertyManager>();
         loadAll();
      }
      public static void setValue(String currency,String name, double value)
      {
         currencys.get(currency.toLowerCase()).setDoubleProperty(name, value);
      }
      public static Set<String> getAllCurrencys()
      {
         return currencys.keySet();
      }
      public static String getConvertMaterial(String currencyName)
      {
         if(currencyList.hasStringProperty(currencyName.toLowerCase()))
            return currencyList.getStringProperty(currencyName.toLowerCase(), "");
         else
            return "NONE";
      }
      public static void setExchangeRate(String currency, double value)
      {
         currencys.get(currency.toLowerCase()).setDoubleProperty("Exchange", value);
      }
      public static double getExchangeRate(String currency)
      {
         return currencys.get(currency.toLowerCase()).getDoubleProperty("Exchange", 1);
      }
      public static boolean add(String name, double amount)
      {
         return add(name,amount,(String)maxCurrency(name)[0]);
      }
      public static boolean add(String name, double amount, String currency)
      {
         double temp = getValue(currency,name);
         setValue(currency,name,getValue(currency,name) + amount);
         return getValue(currency,name) == temp + amount;
      }
      public static boolean subtract(String name, double amount)
      {
         return add(name, -1 * amount);
      }
      public static boolean subtract(String name, double amount, String currency)
      {
         return add(name, -1 * amount, currency);
      }
      public static boolean multiply(String name, double amount)
      {
         return multiply(name, amount, (String)(maxCurrency(name)[0]));
      }
      public static boolean multiply(String name, double amount, String currency)
      {
         return add(name, amount * getValue(currency, name));
      }
      public static boolean divide(String name, double amount)
      {
         return multiply(name, (1.0 / amount));
      }
      public static boolean divide(String name, double amount, String currency)
      {
         return multiply(name, (1.0 / amount), currency);
      }
      public static boolean hasEnough(String name, double amount)
      {
         return hasEnough(name,amount, (String)(maxCurrency(name)[0]));
      }
      public static boolean hasEnough(String name, double amount, String currency)
      {
         return getValue(currency, name) >= amount;
      }
      public static boolean hasOver(String name, double amount)
      {
         return hasOver(name, amount, (String)(maxCurrency(name)[0]));
      }
      public static boolean hasOver(String name, double amount, String currency)
      {
         return getValue(currency, name) > amount;
      }
      public static boolean hasUnder(String name, double amount)
      {
         return hasUnder(name, amount, (String)(maxCurrency(name)[0]));
      }
      public static boolean hasUnder(String name, double amount, String currency)
      {
         return getValue(currency, name) < amount;
      }
      public static boolean isNegative(String name)
      {
         return hasUnder(name, 0);
      }
      public static boolean isNegative(String name, String currency)
      {
         return hasUnder(name, 0, currency);
      }
      public static boolean remove(String name)
      {
         return multiply(name, 0);
      }
      public static boolean remove(String name, String currency)
      {
         return multiply(name, 0, currency);
      }
      public static Object[] maxCurrency(String name)
      {
         String cur = null;
         double amount = 0;
         for(String str : getAllCurrencys())
         {
            if(getValue(str,name) > amount || cur == null)
            {
               amount = getValue(str, name);
               cur = str;
            }
         }
         return new Object[] {cur, amount};
      }
   }