   package me.ashtheking.currency;

   import java.io.*;
   import java.util.Properties;
   import java.util.logging.Level;
   import java.util.logging.Logger;
   import java.util.Set;

   public class PropertyManager
   {
   
      public PropertyManager(String file)
      {
         File f = new File(file);
         serverProperties = new Properties();
         serverPropertiesFile = f;
         String s = serverPropertiesFile.getAbsolutePath();
         f = new File(s.substring(0,s.indexOf(serverPropertiesFile.getPath())-1)+"/plugins/currency/" + file);      
         if(f.exists())
         {
            try
            {
               serverProperties.load(new FileInputStream(f));
            }
               catch(Exception exception)
               {
                  logger.log(Level.WARNING, (new StringBuilder()).append("Failed to load ").append(file).toString(), exception);
                  generateNewProperties();
               }
         } 
         else
         {
            try
            {
               logger.log(Level.WARNING, (new StringBuilder()).append(file).append(" does not exist").toString());
               generateNewProperties();
            }
               catch(Exception e)
               {
                  e.printStackTrace();    
               }
         }
      }
   
      public void generateNewProperties()
      {
         logger.log(Level.INFO, "Generating new properties file");
         saveProperties();
      }
   
      public void saveProperties()
      {
         try
         {
            if(!serverPropertiesFile.exists())
            {
               String s = serverPropertiesFile.getAbsolutePath();
               File f = new File(s.substring(0,s.indexOf(serverPropertiesFile.getPath())-1)+"/plugins/currency/");
               f.mkdirs();
               serverPropertiesFile = new File(f.getAbsolutePath()+"/" + serverPropertiesFile.getPath());
            }
            serverProperties.store(new FileOutputStream(serverPropertiesFile), "MultiCurrency Currency");
         }
            catch(Exception exception)
            {
               logger.log(Level.WARNING, (new StringBuilder()).append("Failed to save ").append(serverPropertiesFile).toString(), exception);
               generateNewProperties();
            }
      }
      public boolean hasStringProperty(String s)
      {
         return serverProperties.containsKey(s);
      }
      public String getStringProperty(String s, String s1)
      {
         if(!serverProperties.containsKey(s))
         {
            serverProperties.setProperty(s, s1);
            saveProperties();
         }
         return serverProperties.getProperty(s, s1);
      }
   
      public double getDoubleProperty(String s, double i)
      {
         try
         {
            return Double.parseDouble(getStringProperty(s, (new StringBuilder()).append("").append(i).toString()));
         }
            catch(Exception exception)
            {
               serverProperties.setProperty(s, (new StringBuilder()).append("").append(i).toString());
            }
         return i;
      }
   
      public boolean getBooleanProperty(String s, boolean flag)
      {
         try
         {
            return Boolean.parseBoolean(getStringProperty(s, (new StringBuilder()).append("").append(flag).toString()));
         }
            catch(Exception exception)
            {
               serverProperties.setProperty(s, (new StringBuilder()).append("").append(flag).toString());
            }
         return flag;
      }
   
      public void setBooleanProperty(String s, boolean flag)
      {
         serverProperties.setProperty(s, (new StringBuilder()).append("").append(flag).toString());
         saveProperties();
      }
      public void setDoubleProperty(String s, double flag)
      {
         serverProperties.setProperty(s, (new StringBuilder()).append("").append(flag).toString());
         saveProperties();
      }
      public Set<String> listProperties()
      {
         return serverProperties.stringPropertyNames();
      }
   
      public static Logger logger = Logger.getLogger("Minecraft");
      private Properties serverProperties;
      private File serverPropertiesFile;
   
   }
